git/Documentation: fix SYNOPSIS style bugs
[git/jnareb-git.git] / git-reset.sh
blob6cb073cb16f8b8d8b923bd0cd77be00da0e169e3
1 #!/bin/sh
3 USAGE='[--mixed | --soft | --hard] [<commit-ish>]'
4 . git-sh-setup
6 tmp=${GIT_DIR}/reset.$$
7 trap 'rm -f $tmp-*' 0 1 2 3 15
9 reset_type=--mixed
10 case "$1" in
11 --mixed | --soft | --hard)
12 reset_type="$1"
13 shift
15 -*)
16 usage ;;
17 esac
19 rev=$(git-rev-parse --verify --default HEAD "$@") || exit
20 rev=$(git-rev-parse --verify $rev^0) || exit
22 # We need to remember the set of paths that _could_ be left
23 # behind before a hard reset, so that we can remove them.
24 if test "$reset_type" = "--hard"
25 then
27 git-ls-files --stage -z
28 git-rev-parse --verify HEAD 2>/dev/null &&
29 git-ls-tree -r -z HEAD
30 } | perl -e '
31 use strict;
32 my %seen;
33 $/ = "\0";
34 while (<>) {
35 chomp;
36 my ($info, $path) = split(/\t/, $_);
37 next if ($info =~ / tree /);
38 if (!$seen{$path}) {
39 $seen{$path} = 1;
40 print "$path\0";
43 ' >$tmp-exists
46 # Soft reset does not touch the index file nor the working tree
47 # at all, but requires them in a good order. Other resets reset
48 # the index file to the tree object we are switching to.
49 if test "$reset_type" = "--soft"
50 then
51 if test -f "$GIT_DIR/MERGE_HEAD" ||
52 test "" != "$(git-ls-files --unmerged)"
53 then
54 die "Cannot do a soft reset in the middle of a merge."
56 else
57 git-read-tree --reset "$rev" || exit
60 # Any resets update HEAD to the head being switched to.
61 if orig=$(git-rev-parse --verify HEAD 2>/dev/null)
62 then
63 echo "$orig" >"$GIT_DIR/ORIG_HEAD"
64 else
65 rm -f "$GIT_DIR/ORIG_HEAD"
67 git-update-ref HEAD "$rev"
69 case "$reset_type" in
70 --hard )
71 # Hard reset matches the working tree to that of the tree
72 # being switched to.
73 git-checkout-index -f -u -q -a
74 git-ls-files --cached -z |
75 perl -e '
76 use strict;
77 my (%keep, $fh);
78 $/ = "\0";
79 while (<STDIN>) {
80 chomp;
81 $keep{$_} = 1;
83 open $fh, "<", $ARGV[0]
84 or die "cannot open $ARGV[0]";
85 while (<$fh>) {
86 chomp;
87 if (! exists $keep{$_}) {
88 # it is ok if this fails -- it may already
89 # have been culled by checkout-index.
90 unlink $_;
91 while (s|/[^/]*$||) {
92 rmdir($_) or last;
96 ' $tmp-exists
98 --soft )
99 ;; # Nothing else to do
100 --mixed )
101 # Report what has not been updated.
102 git-update-index --refresh
104 esac
106 rm -f "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/rr-cache/MERGE_RR"